import * as AST from '../parse/AST';
export declare type DataType = 'byte' | 'word' | 'float' | 'double' | 'ascii' | 'asciiz';
export declare const directives: string[];
export default interface Data {
    type: DataType;
    toInt8Array(): Uint8Array;
    size(): number;
}
export declare function fromAST(node: AST.DataNode): Data;
export declare class Byte implements Data {
    type: DataType;
    private values;
    constructor(values: number[]);
    size(): number;
    toInt8Array(): Uint8Array;
}
export declare class Word implements Data {
    type: DataType;
    private values;
    constructor(values: number[]);
    size(): number;
    toInt8Array(): Uint8Array;
}
export declare class BaseASCII {
    private value;
    private includeNullTerminator;
    constructor(value: string, includeNullTerminator?: boolean);
    size(): number;
    toInt8Array(): Uint8Array;
}
export declare class ASCII extends BaseASCII implements Data {
    type: DataType;
    constructor(value: string);
}
export declare class ASCIIZ extends BaseASCII implements Data {
    type: DataType;
    constructor(value: string);
}
