export declare type InstructionType = 'R' | 'I' | 'J';
export default interface Instruction {
    type: string;
    toInt(): number;
}
export declare const utils: {
    fromInt(instr: number): Instruction;
    isR(instr: Instruction): instr is RInstruction;
    isI(instr: Instruction): instr is IInstruction;
    isJ(instr: Instruction): instr is JInstruction;
};
export declare class RInstruction implements Instruction {
    type: InstructionType;
    op: number;
    rs: number;
    rt: number;
    rd: number;
    sh: number;
    func: number;
    constructor(op: number, rs: number, rt: number, rd: number, sh: number, func: number);
    toInt(): number;
}
export declare class IInstruction implements Instruction {
    type: InstructionType;
    op: number;
    rs: number;
    rt: number;
    imm: number;
    constructor(op: number, rs: number, rt: number, imm: number);
    toInt(): number;
}
export declare class JInstruction implements Instruction {
    type: InstructionType;
    j: number;
    addr: number;
    constructor(j: number, addr: number);
    toInt(): number;
}
