/// <reference types="node" />
import { Readable, Writable } from 'stream';
export interface IOOptions {
    stdin: Readable;
    stdout: Writable;
    stderr: Writable;
}
export default class IO {
    private stdin;
    private stdout;
    private stderr;
    private inBuffer;
    constructor({stdin, stdout, stderr}: IOOptions);
    readChar(): Promise<string>;
    private readUntilMatch(re);
    read(): Promise<string>;
    readInt(): Promise<number>;
    readFloat(): Promise<number>;
    write(data: string): void;
    writeErr(data: string): void;
}
