/// <reference types="node" />
import { EventEmitter } from 'events';
import { Readable, Writable } from 'stream';
import AssembledObject from '../assemble/AssmebledObject';
import PrimaryRegisters from './PrimaryRegisters';
export interface MIPSOptions {
    stdin: Readable;
    stdout: Writable;
    stderr: Writable;
    source: string;
}
export interface MIPSEmitter {
}
export default class MIPS extends EventEmitter implements MIPSEmitter {
    private source;
    private io;
    assembledObj: AssembledObject;
    registers: PrimaryRegisters;
    private dataMemory;
    private heapMemory;
    private stack;
    private exited;
    constructor(options: MIPSOptions);
    updateSource(source: string): void;
    assemble(): void;
    isAssembled(): boolean;
    execute(): Promise<void>;
    executeNextInstruction(): Promise<boolean>;
    private executeInstruction(i);
    private resolveInstructionIndex();
    private resolveMemory(address);
    private readByte(address);
    private writeByte(address, value);
    private readHalf(address);
    private writeHalf(address, value);
    private readWord(address);
    private writeWord(address, value);
    private readASCIIString(address);
    private syscall(code);
}
