/// <reference types="node" />
import { EventEmitter } from 'events';
export interface MemoryOptions {
    size: number;
    fixed?: boolean;
    initial?: Uint8Array;
    baseAddress?: number;
}
export interface MemoryChangeEvent {
    address: number;
    prevValue: number;
    nextValue: number;
}
export interface MemoryEmitter {
    on(event: 'change', listener: (changeEvent: MemoryChangeEvent) => void): void;
}
export default class Memory extends EventEmitter implements MemoryEmitter {
    protected data: Uint8Array;
    protected size: number;
    protected fixed: boolean;
    protected baseAddress: number;
    constructor({size, initial, fixed, baseAddress}: MemoryOptions);
    private clone(data);
    protected resolveIndex(address: number): number;
    protected resolveAddress(index: number): number;
    private expand(size);
    get(address: number): number;
    set(address: number, value: number): void;
    getSize(): number;
}
