/// <reference types="node" />
import { EventEmitter } from 'events';
export interface RegisterOptions {
    size: number;
    mappings: {
        [key: string]: number;
    };
}
export interface RegisterChangeEvent {
    name: string;
    index: number;
    prevValue: number;
    nextValue: number;
}
export interface RegistersEmitter {
    on(event: 'change', listener: (changeEvent: RegisterChangeEvent) => void): void;
}
export default class Registers extends EventEmitter implements RegistersEmitter {
    size: number;
    protected nameToIndex: {
        [key: string]: number;
    };
    protected indexToName: {
        [key: number]: string;
    };
    protected registers: Uint32Array;
    constructor(options: RegisterOptions);
    set(register: string | number, value: number): void;
    get(register: string | number, signed?: boolean): number;
    getUnsigned(register: string | number): number;
}
