"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Memory_1 = require("./Memory");
// Stack overrides Memory's `resolveIndex` and `resolveAddress` to provide a LIFO interface
var Stack = /** @class */ (function (_super) {
    tslib_1.__extends(Stack, _super);
    function Stack(_a) {
        var end = _a.end, size = _a.size;
        var _this = _super.call(this, { size: size }) || this;
        _this.end = end;
        return _this;
    }
    // Override => last address = first index...
    Stack.prototype.resolveIndex = function (address) {
        return this.end - 1 - address;
    };
    // Override => first index = last address...
    Stack.prototype.resolveAddress = function (index) {
        return this.end - 1 + index;
    };
    return Stack;
}(Memory_1.default));
exports.default = Stack;
